#include "types.h"
#include "io.h"

void init_gdt(void);
void init_idt(void);
void init_pic(void);

void print (char*);

extern int kY;
extern int kattr;


int main(void);

void _start(void) {
    main();
}

int main(void) {
    cli;

    init_gdt();
    asm("   movw $0x18, %ax \n \
            movw %ax, %ss \n \
            movl $0x1FFFF, %esp");

    kY = 16;
    kattr = 0x0E;
    print("kernel : gdt loaded\n");

    init_idt();
    print("kernel : idt loaded\n");

    init_pic();
    print("kernel : pic configured\n");

    sti; 
    kattr = 0x47;
    print("kernel : allowing interrupt\n");
    kattr = 0x07;

    show_cursor();

    while(1);
}

